#ifndef AI_H
#include "Player.h"
#include "InfoManager.h"
#include "StrategyManager.h"
#include "ProductionManager.h"
#include "BuildManager.h"
#include "SquadManager.h"
#include "WorkerManager.h"
#include "Game.h"
#define AI_H

/**
 * Classe principal da IA, faz o gerenciamento de macro e micro de um jogador
 */
class AI {
public:
    AI(Game* game, Player* player);
    virtual ~AI();
    void run();
    int getTeam();
    void insertUnit(Unit* unit);
    void removeUnit(Unit* unit);
    void insertBuilding(Building* building);
    void removeBuilding(Building* building);
    InfoManager* infoManager_;
    StrategyManager* strategyManager_;
    ProductionManager* productionManager_;
    BuildManager* buildManager_;
    SquadManager* squadManager_;
    WorkerManager* workerManager_;

protected:
private:
    Game* game_;
    Player* player_;

};

#endif // AI_H
