#ifndef INFOMANAGER_H
#include "Manager.h"
#include "maxflowgraph.h"
#include "Define.h"
#define INFOMANAGER_H

/**
 * Contem informacoes da localizacao dos pontos de estrangulamento, das bases aliada e inimiga
 */
class InfoManager : public Manager {
public:
    InfoManager(Game* game, Player* player);
    virtual ~InfoManager();
    void init();
    bool insertUnit(Unit* unit);
    bool removeUnit(Unit* unit);
    bool insertBuilding(Building* building);
    bool removeBuilding(Building* building);
    bool requestBuilding(int buildType);
    void makeGraph();
    void setTWeights();
    void setChokePoint();
    void setAttack();
    void run();
    std::pair<float,float> ourBase;
    std::pair<float,float> enemyBase;
    std::pair<float,float> chokePoint;
    std::pair<float,float> attackPoint;
    std::map<int,std::vector<Unit*>> ourUnitSet;
    std::map<int,std::vector<Building*>> ourBuildingSet;
    std::vector<int> buildOrder;
    Unit* worker;
    std::pair<float,float> buildLocation;
    int barracksProduction;
    bool findNewAttackPoint;

protected:
private:
    MaxflowGraph::node_id** nodes;
    MaxflowGraph *maxflowGraph;

};
#endif // INFOMANAGER_H
