#ifndef COLLISION_H
#include "vector"
#include "Quadtree.h"
#include "Rect.h"
#include "Unit.h"
#include "Graph.h"
#include "Mymath.h"
#include "Define.h"
#define COLLISION_H

/**
 * Contem rotinas relacionadas a colisao
 */
class Collision {
public:
    Collision(Graph* graph);
    virtual ~Collision();
    Quadtree* getQt();
    void solve(std::vector<Unit*> unitSet);

protected:
private:
    Graph* graph_;
    Rect* ret;
    Quadtree* qt;
    bool isWalkable(float px, float py);
    std::pair<float,float> getCollision(Unit* unitA, Unit* unitB);
};

#endif // COLLISION_H
