#ifndef PATHFINDING_H
#include <vector>
#include "Unit.h"
#include "Building.h"
#include "Define.h"
#include "Graph.h"
#include "Mymath.h"
#define PATHFINDING_H

/**
 * Contem rotinas relacionadas a busca de caminho
 */
class Pathfinding {
public:
    Pathfinding(Graph* graph);
    virtual ~Pathfinding();
    std::vector<std::pair<float,float>> bfsPathfinding(float sx, float sy, float tx, float ty);
    std::vector<std::pair<float,float>> astarPathfinding(float sx, float sy, float tx, float ty);
    std::vector<std::pair<float,float>> dijkstraPathfinding(float sx, float sy, float tx, float ty);
    std::vector<std::pair<int,int>> getPath(Node* s, Node* t);
    std::vector<std::pair<float,float>> transformPath(std::vector<std::pair<int,int>> path, float tx, float ty);
    std::vector<std::pair<float,float>> getWalkingPath(std::vector<std::pair<float,float>> pixelPath);
    std::set<int> getZE(Unit* unit);
    std::set<int> getZE(Building* building);
    std::set<int> getZE(float px, float py);
    bool isInSameZE(std::set<int> ze1, std::set<int> ze2);
    std::pair<float,float> findNearestTile(float tx, float ty, std::set<int> zones);

protected:
private:
    Graph* graph_;
};

#endif // PATHFINDING_H
