/* Codigo baseado do site:
http://gamedev.tutsplus.com/tutorials/implementation/quick-tip-use-quadtrees-to-detect-likely-collisions-in-2d-space/ */

#ifndef QUADTREE_H
#include <vector>
#include "Unit.h"
#include "Rect.h"
#define QUADTREE_H

/**
 * Contem rotinas relacionadas a Quadtree
 */
class Quadtree {
public:
    Quadtree(int pLevel, Rect* pBounds);
    virtual ~Quadtree();
    Rect* getBounds();
    Quadtree** getNodes();
    std::vector<Unit*> getObjects();

    void insert(Unit* unit);
    void split();
    void clear();
    int getIndex(Unit* unit);
    std::vector<Unit*> retrieve(std::vector<Unit*> returnObjects, Unit* unit);

protected:
private:
    int MAX_OBJECTS;
    int MAX_LEVELS;
    int level;
    Rect* bounds;
    Quadtree** nodes;
    std::vector<Unit*> objects;

};

#endif // QUADTREE_H
