#ifndef MAP_H
#include <cstdio>
#include <string>
#include <vector>
#include "Define.h"
#include "Tile.h"
#define MAP_H

/**
 * Contem caracteristicas do mapa em formato texto
 */
class Map {
public:
    Map(const char* mapname, const char* configname);
    virtual ~Map();
    int getRows();
    int getColumns();
    std::vector<std::string> getMapMatrix();
    const char* getConfigName();
    Tile*** getTiles();
    void render();

protected:
private:
    int rows_;
    int columns_;
    std::vector<std::string> mapMatrix_;
    const char* configname_;
    Tile*** tiles_;
    void loadMap(const char* mapname);
    void loadTiles();
    std::vector<std::string> transpose(std::vector<std::string> matrix);
};

#endif // MAP_H
