#ifndef PLAYER_H
#include <vector>
#include <algorithm>
#include "Unit.h"
#include "Building.h"
#define PLAYER_H

/**
 * Contem informacoes do jogador
 */
class Player {
public:
    Player(int team, int gold, int unitCap, ALLEGRO_COLOR color);
    virtual ~Player();
    int getTeam();
    int getGold();
    int getUnitCount();
    void setUnitCount(int unitCount);
    int getUnitCap();
    void setUnitCap(int unitCap);
    ALLEGRO_COLOR getColor();
    std::vector<Unit*> getUnitSet();
    std::vector<Building*> getBuildingSet();
    void sumGold(int gold);
    void sumUnitCount(int unitCount);
    void insertUnit(Unit* unit);
    bool removeUnit(Unit* unit);
    void insertBuilding(Building* building);
    bool removeBuilding(Building* building);

protected:
private:
//    AI* ai_;
    int team_;
    int gold_;
    int unitCount_;
    int unitCap_;
    ALLEGRO_COLOR color_;
    std::vector<Unit*> unitSet_;
    std::vector<Building*> buildingSet_;
};

#endif // PLAYER_H

