#ifndef STATE_H
#include <cstdio>
#include "StateManager.h"
#include "allegro5/allegro.h"
#include "allegro5/allegro_image.h"
#include "allegro5/allegro_native_dialog.h"
#include "allegro5/allegro_primitives.h"
#include "allegro5/allegro_font.h"
#include "allegro5/allegro_ttf.h"
#define STATE_H

enum STATE {PLAYING, PAUSE};

/**
 * Estado do jogo
 */
class State {
public:
    virtual ~State();
    virtual void readInput(StateManager* sm) = 0;
    virtual void update(StateManager* sm) = 0;
    virtual void render(StateManager* sm) = 0;
    void changeState(StateManager* sm, State* state) {
        sm->changeState(state);
    }
protected:
    ALLEGRO_DISPLAY* display_;
    ALLEGRO_TIMER* timer_;
    ALLEGRO_EVENT_QUEUE* queue_;
    ALLEGRO_FONT* font;
    bool redraw;
    State(ALLEGRO_DISPLAY* display, ALLEGRO_TIMER* timer, ALLEGRO_EVENT_QUEUE* queue);

private:
};

#endif // STATE_H
