#ifndef NODE_H
#include <cstdio>
#define NODE_H

/**
 * No' do grafo
 */
class Node {
public:
    Node(int x, int y);
    virtual ~Node();
    int getX();
    void setX(int x);
    int getY();
    void setY(int y);
    int getType();
    void setType(int type);
    int getTileType();
    void setTileType(int tileType);
    int getZone();
    void setZone(int zone);
    int getTeam();
    void setTeam(int team);
    float getCost();
    void setCost(float cost);
    float getDist();
    void setDist(float dist);
    float getEstimate();
    void setEstimate(float estimate);
    bool isWalkable();
    void setWalkable(bool walkable);
    bool isOnPath();
    void setOnPath(bool onPath);
    int getChoke();
    void setChoke(int choke);
    Node* getParent();
    void setParent(Node* parent);

protected:
private:
    int x_;
    int y_;
    int type_;
    int tileType_;
    int zone_;
    int team_;
    double cost_;
    double dist_;
    double estimate_;
    bool walkable_;
    bool onPath_; // Apenas pra debug
    int choke_;
    Node* parent_;
};

#endif // NODE_H

