#ifndef GUI_H
#include <cstdio>
#include "allegro5/allegro.h"
#include "allegro5/allegro_font.h"
#include "allegro5/allegro_image.h"
#include "allegro5/allegro_ttf.h"
#include <allegro5/allegro_primitives.h>
#include "Game.h"
#include "nihgui.h"
#include "Mymath.h"
#define GUI_H

enum ACTION_STATE {IDLE, SELECT_UNIT, SELECT_BUILDING, TARGET};

/**
 * Interface do usuario
 */
class Gui {
public:
    Gui(const Theme & theme, ALLEGRO_DISPLAY *display);
    virtual ~Gui();
    float getPx();
    void setPx(float px);
    float getPy();
    void setPy(float py);
    float getWidth();
    void setWidth(float width);
    float getHeight();
    void setHeight(float height);
    std::string getAction();
    void setRectangle(float px, float py, float width, float height);
    void setGame(Game* game);
    void setSelect(std::vector<Unit*> select);
    void setSelectBuilding(Building* selectBuilding);
    void update(int aState);
    void render();

protected:
private:
    float px_;
    float py_;
    float width_;
    float height_;
    int aState_;
    Dialog* d;
    Button** button;
    std::vector<Unit*> select_;
    Building* selectBuilding_;
    Game* game_;
    void renderUnit();
    void renderBuilding();
    void renderStatus();
};

#endif // GUI_H
