#ifndef Building_H
#include "Define.h"
#include "Unit.h"
#include "Entity.h"
#include "UnitProperty.h"
#include "BuildingProperty.h"
#include <allegro5/allegro_primitives.h>
#define Building_H

/**
 * Classe de edificios
 */
class Building : public Entity {
public:
    Building(int x, int y, int type, int team);
    virtual ~Building();
    void setReady();
    int getX();
    void setX(int x);
    int getY();
    void setY(int y);
    float getTrainingTime();
    void setTrainingTime(float trainingTime);
    float getBuildingTime();
    void setBuildingTime(float buildingTime);
    float getMiningTime();
    void setMiningTime(float miningTime);
    bool isConstructing();
    void setConstructing(bool constructing);
    std::vector<int> getQueue();
    void setQueue(std::vector<int> queue);
    std::vector<Unit*> getSlot();
    bool insertSlot(Unit* unit);
    bool releaseSlot();

    float getRadius();
    float getMaxHp();
    int getDimension();
    int getCost();
    std::vector<std::string> getAction();
    ALLEGRO_BITMAP* getBitmap();
    std::string getName();
    float getTime();

    int getMaxSlot();
    int getMaxQueue();
    int getMiningGain();
    float getMiningCooldown();

    bool isActive();
    bool isBuilding();
    bool insertQueue(int unitType);
    bool removeQueue(int pos);
    void construct();
    void update();
    void render();

protected:
private:
    int x_;
    int y_;
    float trainingTime_;
    float buildingTime_;
    float miningTime_;
    bool constructing_;
    std::vector<int> queue_;
    std::vector<Unit*> slot_;
};

#endif // Building_H
