#ifndef ENTITY_H
#include <vector>
#include "allegro5/allegro.h"
#include "allegro5/allegro_image.h"
#define ENTITY_H

/**
 * Classe das entidades
 */
class Entity {
public:
    virtual ~Entity();
    float getPx();
    void setPx(float px);
    float getPy();
    void setPy(float px);
    int getType();
    void setType(int type);
    int getTeam();
    void setTeam(int team);
    float getHp();
    void setHp(float hp);
    std::vector<std::pair<float,float>> getPixelPath();
    void setPixelPath(std::vector<std::pair<float,float>> pixelPath);
    Entity* getEntity();
    void setEntity(Entity* entity);

    virtual float getRadius() = 0;
    virtual float getMaxHp() = 0;
    virtual bool isBuilding();
    virtual bool isUnit();

    std::pair<float,float> getCoordinates();
    void setCoordinates(float px, float py);
    void receiveDamage(float damage);

protected:
    Entity();
    float px_;
    float py_;
    int type_;
    int team_;
    float hp_;
    std::vector<std::pair<float,float>> pixelPath_;
    Entity* entity_;

private:
};

#endif // ENTITY_H
