#ifndef PROJECTILE_H
#include <cmath>
#include "ProjectileProperty.h"
#include "Entity.h"
#include "allegro5/allegro.h"
#include "Define.h"
#define PROJECTILE_H

/**
 * Classe de projeteis
 */
class Projectile {
public:
    Projectile(float px, float py, float damage, int type, Entity* target);
    virtual ~Projectile();
    float getPx();
    float getPy();
    float getAngle();
    float getDamage();
    int getType();
    Entity* getTarget();

    float getSpeed();
    float getRadius();
    ALLEGRO_BITMAP* getBitmap();

    std::pair<float,float> getNextMovement();
    void move(std::pair<float,float> d);
    void update();
    void render();

protected:
private:
    float px_;
    float py_;
    float angle_;
    float damage_;
    int type_;
    Entity* target_;
};

#endif // PROJECTILE_H
