#ifndef BUILDINGPROPERTY_H
#include <cstdio>
#include <map>
#include <vector>
#include <string>
#include "TileProperty.h"
#include "allegro5/allegro.h"
#define BUILDINGPROPERTY_H

enum BUILDING_TYPE {HALL, GOLD_MINE, BARRACKS, b_count};

/**
 * Classe que contem as propriedades dos edificios
 */
class BuildingProperty {
public:
    virtual ~BuildingProperty();
    static BuildingProperty* getInstance() {
        if (instance == NULL) {
            instance = new BuildingProperty();
        }
        return instance;
    }
    void loadCost();
    void loadDimension();
    void loadTileType();
    void loadMaxSlot();
    void loadMaxQueue();
    void loadMiningGain();
    void loadMiningCooldown();
    void loadMaxHp();
    void loadRadius();
    void loadTime();
    void loadName();
    void loadAction();
    void loadBitmap();
    void loadIcon();

    int getCost(int type);
    int getDimension(int type);
    int getTileType(int type);
    int getMaxSlot(int type);
    int getMaxQueue(int type);
    int getMiningGain(int type);
    float getMiningCooldown(int type);
    float getMaxHp(int type);
    float getRadius(int type);
    float getTime(int type);
    std::string getName(int type);
    std::vector<std::string> getAction(int type);
    ALLEGRO_BITMAP* getBitmap(int type);
    ALLEGRO_BITMAP* getIcon(int type);

    int getType(std::string name);

protected:
private:
    BuildingProperty();
    static BuildingProperty* instance;
    std::map <int,int> cost_;
    std::map <int,int> dimension_;
    std::map <int,int> tileType_;
    std::map <int,int> maxSlot_;
    std::map <int,int> maxQueue_;
    std::map <int,int> miningGain_;
    std::map <int,float> miningCooldown_;
    std::map <int,float> maxhp_;
    std::map <int,float> time_;
    std::map <int,float> radius_;
    std::map <int,std::string> name_;
    std::map <int,std::vector<std::string>> action_;
    std::map <int,ALLEGRO_BITMAP*> bitmap_;
    std::map <int,ALLEGRO_BITMAP*> icon_;
};

#endif // BUILDINGPROPERTY_H
