#ifndef COMMANDPROPERTY_H
#include <cstdio>
#include <map>
#include <vector>
#include <string>
#include "allegro5/allegro.h"
#define COMMANDPROPERTY_H


enum COMMAND_TYPE {MOVE,STOP,ATTACK,UNLOAD,RALLY,GATHER,c_count};
/**
 * Classe que contem as propriedades dos comandos
 */
class CommandProperty {
public:
    static CommandProperty* getInstance() {
        if(instance == NULL) {
            instance = new CommandProperty();
        }
        return instance;
    }
    virtual ~CommandProperty();
    void loadIcon();
    void loadName();
    std::string getName(int type);
    ALLEGRO_BITMAP* getIcon(int type);
    int getType(std::string name);

protected:
private:
    CommandProperty();
    static CommandProperty* instance;
    std::map <int,std::string> name_;
    std::map <int,ALLEGRO_BITMAP*> icon_;
};


#endif // COMMANDPROPERTY_H
