#ifndef PROJECTILEPROPERTY_H
#include <cstdio>
#include <map>
#include "allegro5/allegro.h"
#define PROJECTILEPROPERTY_H

enum PROJECTILE_TYPE {MELEE, ARROW, p_count};
/**
 * Classe que contem as propriedades dos projeteis
 */
class ProjectileProperty {
public:
    static ProjectileProperty* getInstance() {
        if(instance == NULL) {
            instance = new ProjectileProperty();
        }
        return instance;
    }
    virtual ~ProjectileProperty();

    void loadSpeed();
    void loadRadius();
    void loadBitmap();

    float getSpeed(int type);
    float getRadius(int type);
    ALLEGRO_BITMAP* getBitmap(int type);

protected:
private:
    ProjectileProperty();
    static ProjectileProperty* instance;
    std::map <int,float> speed_;
    std::map <int,float> radius_;
    std::map <int,ALLEGRO_BITMAP*> bitmap_;
};

#endif // PROJECTILEPROPERTY_H
