#ifndef TILEPROPERTY_H
#include <cstdio>
#include <map>
#include "allegro5/allegro.h"
#define TILEPROPERTY_H

enum TILE_TYPE {GRASS, TREE, GOLD, t_count};
/**
 * Classe que contem as propriedades dos tiles
 */
class TileProperty {
public:
    static TileProperty* getInstance() {
        if (instance == NULL) {
            instance = new TileProperty();
        }
        return instance;
    }
    virtual ~TileProperty();
    void loadTileType();
    void loadChar();
    void loadWalkable();
    void loadBitmap();

    int getTileType(int type);
    char getChar(int type);
    bool isWalkable(int type);
    ALLEGRO_BITMAP* getBitmap(int type);
    int getType(char c);

protected:
private:
    TileProperty();
    static TileProperty* instance;
    std::map <int,int> tileType_;
    std::map <int,char> char_;
    std::map <int,bool> walkable_;
    std::map <int,ALLEGRO_BITMAP*> bitmap_;
};

#endif // TILEPROPERTY_H
