#ifndef UNITPROPERTY_H
#include <cstdio>
#include <map>
#include <vector>
#include <string>
#include "ProjectileProperty.h"
#include "allegro5/allegro.h"
#define UNITPROPERTY_H

enum UNIT_TYPE {WORKER, WARRIOR, ARCHER, u_count};
/**
 * Classe que contem as propriedades das unidades
 */
class UnitProperty {
public:
    virtual ~UnitProperty();
    static UnitProperty* getInstance() {
        if (instance == NULL) {
            instance = new UnitProperty();
        }
        return instance;
    }
    void loadCost();
    void loadProjectile();
    void loadCount();
    void loadMaxHp();
    void loadDamage();
    void loadAttackSpeed();
    void loadRange();
    void loadAggroRadius();
    void loadSpeed();
    void loadRadius();
    void loadTime();
    void loadName();
    void loadAction();
    void loadBitmap();
    void loadIcon();

    int getCost(int type);
    int getProjectile(int type);
    int getCount(int type);
    float getMaxHp(int type);
    float getDamage(int type);
    float getAttackSpeed(int type);
    float getRange(int type);
    float getAggroRadius(int type);
    float getSpeed(int type);
    float getRadius(int type);
    float getTime(int type);
    std::string getName(int type);
    std::vector<std::string> getAction(int type);
    std::vector<ALLEGRO_BITMAP*> getBitmap(int type);
    ALLEGRO_BITMAP* getIcon(int type);

    int getType(std::string name);
    int fps; // nao deveria estar aqui

protected:
private:
    UnitProperty();
    static UnitProperty* instance;
    std::map <int,int> cost_;
    std::map <int,int> projectile_;
    std::map <int,int> count_;
    std::map <int,float> maxhp_;
    std::map <int,float> damage_;
    std::map <int,float> speed_;
    std::map <int,float> attackspeed_;
    std::map <int,float> time_;
    std::map <int,float> radius_;
    std::map <int,float> aggroradius_;
    std::map <int,float> range_;
    std::map <int,std::string> name_;
    std::map <int,std::vector<std::string>> action_;
    std::map <int,std::vector<ALLEGRO_BITMAP*>> bitmap_;
    std::map <int,ALLEGRO_BITMAP*> icon_;

};

#endif //UNITPROPERTY_H
