#include "ProductionManager.h"

/**
 * Construtor
 * @param game Ponteiro do game
 * @param player Ponteiro do player
 * @param infoManager Ponteiro do infoManager
 */
ProductionManager::ProductionManager(Game* game, Player* player, InfoManager* infoManager) : Manager(game,player), infoManager_(infoManager) {

}

/**
 * Destrutor
 */
ProductionManager::~ProductionManager() {

}

/**
 * Executa rotina de producao de unidades
 */
void ProductionManager::run() {
    int numWorker = infoManager_->ourUnitSet[UNIT_TYPE::WORKER].size();
    int numGoldMine = infoManager_->ourBuildingSet[BUILDING_TYPE::GOLD_MINE].size();
    int maxSlot = BuildingProperty::getInstance()->getMaxSlot(BUILDING_TYPE::GOLD_MINE);
    // Se o numero de unidades trabalhadoras for menor que o numero de mina de ouro * slot, cria uma unidade trabalhadora
    if(numWorker < numGoldMine*maxSlot) {
        for(int i = 0; i < (int) infoManager_->ourBuildingSet[BUILDING_TYPE::HALL].size(); i++) {
            Building* b = infoManager_->ourBuildingSet[BUILDING_TYPE::HALL][i];
            if(b->getQueue().size() == 0) { // Talvez verificar se esta ativo
                Building* gm = NULL;
                for(int j = 0; j < (int) infoManager_->ourBuildingSet[BUILDING_TYPE::GOLD_MINE].size(); j++) {
                    gm = infoManager_->ourBuildingSet[BUILDING_TYPE::GOLD_MINE][j];
                    if((int) gm->getSlot().size() < BuildingProperty::getInstance()->getMaxSlot(BUILDING_TYPE::GOLD_MINE)) {
                        gm = infoManager_->ourBuildingSet[BUILDING_TYPE::GOLD_MINE][j];
                        break;
                    }
                }
                game_->insertBuildingQueue(b, UNIT_TYPE::WORKER);
                game_->executeCommand("Rally", b, gm->getPx(), gm->getPy());
            }
        }
    }
    // Se houver requisicao de criacao de unidade de combate
    if(infoManager_->barracksProduction != -1) {
        for(int i = 0; i < (int) infoManager_->ourBuildingSet[BUILDING_TYPE::BARRACKS].size(); i++) {
            Building* b = infoManager_->ourBuildingSet[BUILDING_TYPE::BARRACKS][i];
            if(b->getQueue().size() == 0) { // Talvez verificar se esta ativo
                game_->insertBuildingQueue(b, infoManager_->barracksProduction);
                game_->executeCommand("Rally", b, infoManager_->chokePoint.first, infoManager_->chokePoint.second);
            }
        }
    }
    // Se o gold do jogador for maior ou igual ao custo de um novo quartel + (numero de quarteis)*(custo da unidade que esta sendo produzida) entao cria um novo quartel
    if(player_->getGold() >= (int) (BuildingProperty::getInstance()->getCost(BUILDING_TYPE::BARRACKS) +
                            infoManager_->ourBuildingSet[BUILDING_TYPE::BARRACKS].size()*infoManager_->barracksProduction*UnitProperty::getInstance()->getCost(infoManager_->barracksProduction))) {
        infoManager_->requestBuilding(BUILDING_TYPE::BARRACKS);
    }
}
