#include "SquadManager.h"

/**
 * Construtor
 * @param game Ponteiro do game
 * @param player Ponteiro do player
 * @param infoManager Ponteiro do infoManager
 */
SquadManager::SquadManager(Game* game, Player* player, InfoManager* infoManager) : Manager(game,player), infoManager_(infoManager) {
}

/**
 * Destrutor
 */
SquadManager::~SquadManager() {
}

/**
 * Executa rotina do microgerenciamento
 */
void SquadManager::run() {
    // Envia tropas para o choke point
    if(getSquadQuantity() <= 5) {
        attackMove(infoManager_->chokePoint.first, infoManager_->chokePoint.second);
    }
    // Envia tropas para o attack point
    else {
        attackMove(infoManager_->attackPoint.first, infoManager_->attackPoint.second);
    }
}

/**
 * Utiliza o comando attack-move para cada tropa de combate ao ponto (px,py)
 * @param px Coordenada x em pixel
 * @param py Coordenada y em pixel
 */
void SquadManager::attackMove(float px, float py) {
    // Envia guerreiros
    for(int i = 0; i < (int) infoManager_->ourUnitSet[UNIT_TYPE::WARRIOR].size(); i++) {
        if(infoManager_->ourUnitSet[UNIT_TYPE::WARRIOR][i]->movePosition.first != px && infoManager_->ourUnitSet[UNIT_TYPE::WARRIOR][i]->movePosition.second != py) {
            std::vector<Unit*> select;
            select.push_back(infoManager_->ourUnitSet[UNIT_TYPE::WARRIOR][i]);
            game_->executeCommand("Attack", select, px, py);
        }
    }
    // Envia arqueiros
    for(int i = 0; i < (int) infoManager_->ourUnitSet[UNIT_TYPE::ARCHER].size(); i++) {
        if(infoManager_->ourUnitSet[UNIT_TYPE::ARCHER][i]->movePosition.first != px && infoManager_->ourUnitSet[UNIT_TYPE::ARCHER][i]->movePosition.second != py) {
            std::vector<Unit*> select;
            select.push_back(infoManager_->ourUnitSet[UNIT_TYPE::ARCHER][i]);
            game_->executeCommand("Attack", select, px, py);
        }
    }
}

/**
 * @return Numero de unidades de combate
 */
int SquadManager::getSquadQuantity() {
    return infoManager_->ourUnitSet[UNIT_TYPE::WARRIOR].size() + infoManager_->ourUnitSet[UNIT_TYPE::ARCHER].size();
}
