#include "Player.h"

/**
 * Construtor
 * @param team Numero do time
 * @param gold Quantidade de ouro
 * @param unitCap Numero maximo de unidades
 * @param color Cor do time
 */
Player::Player(int team, int gold, int unitCap, ALLEGRO_COLOR color) : team_(team), gold_(gold), unitCap_(unitCap), color_(color) {
    unitCount_ = 0;
}

/**
 * Destrutor
 */
Player::~Player() {

}

/**
 * @return Numero do time
 */
int Player::getTeam() {
    return team_;
}

/**
 * @return Quantidade de ouro
 */
int Player::getGold() {
    return gold_;
}

/**
 * @return Quantidade de unidades
 */
int Player::getUnitCount() {
    return unitCount_;
}

/**
 * Atribui uma quantidade de unidades
 * @param unitCount Quantidade de unidades
 */
void Player::setUnitCount(int unitCount) {
    unitCount_ = unitCount;
}

/**
 * @return Numero maximo de unidades
 */
int Player::getUnitCap() {
    return unitCap_;
}

/**
 * Atribui uma quantidade maxima de unidades
 * @param unitCap Numero maximo de unidades
 */
void Player::setUnitCap(int unitCap) {
    unitCap_ = unitCap;
}

/**
 * @return Cor do time
 */
ALLEGRO_COLOR Player::getColor() {
    return color_;
}

/**
 * @return Vetor de unidades do jogador
 */
std::vector<Unit*> Player::getUnitSet() {
    return unitSet_;
}

/**
 * @return Vetor de edifcios do jogador
 */
std::vector<Building*> Player::getBuildingSet() {
    return buildingSet_;
}

/**
 * Soma gold a quantidade de ouro do jogador
 * @param gold Quantidade de ouro a ser acrescida
 */
void Player::sumGold(int gold) {
    gold_ = gold_ + gold;
}

/**
 * Soma unitCount a quantidade de unidades do jogador
 * @param unitCount Quantidade de unidades a ser acrescida
 */
void Player::sumUnitCount(int unitCount) {
    unitCount_ = unitCount_ + unitCount;
}

/**
 * Insere unit ao vetor de unidades do jogador
 * @param unit Ponteiro da unidade
 */
void Player::insertUnit(Unit* unit) {
    unitSet_.push_back(unit);
    //ai_->insertUnit(unit);
}

/**
 * Remove unit do vetor de unidades do jogador
 * @param unit Ponteiro da unidade
 * @return true se removeu, false caso contrario
 */
bool Player::removeUnit(Unit* unit) {
    std::vector<Unit*>::iterator it;
    it = find (unitSet_.begin(), unitSet_.end(), unit);
    if (it != unitSet_.end()) {
        unitSet_.erase(it);
        return true;
    }
    return false;
}

/**
 * Insere unit ao vetor de unidades do jogador
 * @param building Ponteiro da unidade
 */
void Player::insertBuilding(Building* building) {
    buildingSet_.push_back(building);
}

/**
 * Remove unit do vetor de edificios do jogador
 * @param building Ponteiro do edificio
 * @return true se removeu, false caso contrario
 */
bool Player::removeBuilding(Building* building) {
    std::vector<Building*>::iterator it;
    it = find (buildingSet_.begin(), buildingSet_.end(), building);
    if (it != buildingSet_.end()) {
        buildingSet_.erase(it);
        return true;
    }
    return false;
}


