#include "StateManager.h"
#include "State.h"

/**
 * Construtor
 * @param display Tela do jogo
 * @param timer Tempo de atualizacao
 * @param queue Fila de eventos
 */
StateManager::StateManager(ALLEGRO_DISPLAY* display, ALLEGRO_TIMER* timer, ALLEGRO_EVENT_QUEUE* queue) {
    running = true;
}

/**
 * Destrutor
 */
StateManager::~StateManager() {
}

/**
 * Muda estado do simulador para state
 * @param state Novo estado
 */
void StateManager::changeState(State* state) {
    //al_rest(0.5); //quando ta mudando d estado, o fps atual nao atualiza imediatamente
    currentState = state;
}

/**
 * Le entrada
 */
void StateManager::readInput() {
    currentState->readInput(this);
}

/**
 * Atualiza
 */
void StateManager::update() {
    currentState->update(this);
}

/**
 * Renderiza
 */
void StateManager::render() {
    currentState->render(this);
}

/**
 * @return true se estiver executando, false caso contrario
 */
bool StateManager::isRunning() {
    return running;
}

/**
 * Sai do programa
 */
void StateManager::quit() {
    running = false;
}
