#include <cstdio>
#include "Edge.h"

/**
 * Construtor
 * @param node No' do grafo
 * @param cost Custo da aresta
 * @param next Proxima aresta
 */
Edge::Edge(Node* node, float cost, Edge* next) : node_(node), cost_(cost), next_(next) {
}

/**
 * Destrutor
 */
Edge::~Edge() {
    delete next_;
}

/**
 * @return No' do grafo
 */
Node* Edge::getNode() {
    return node_;
}

/**
 * Atribui um no' a aresta
 * @param node No' do grafo
 */
void Edge::setNode(Node* node) {
    node_ = node;
}

/**
 * @return Custo da aresta
 */
float Edge::getCost() {
    return cost_;
}

/**
 * Atribui um valor cost a aresta
 * @param cost Custo da aresta
 */
void Edge::setCost(float cost) {
    cost_ = cost;
}

/**
 * @return Proxima aresta
 */
Edge* Edge::getNext() {
    return next_;
}

/**
 * Atribui a proxima aresta
 * @param next Proxima aresta
 */
void Edge::setNext(Edge* next) {
    next_ = next;
}

/**
 * Imprime aresta e a posicao de seu respectivo no
 */
void Edge::show() {
    printf("w: (%d,%d), cost: %f, ", (*node_).getX(), (*node_).getY(), cost_);
    printf("next: ");
    if(next_ != NULL) {
        printf("(%d,%d)\n", next_->getNode()->getX(), next_->getNode()->getY());
    }
    else {
        printf("NULL\n");
    }
}
