#include <cstdio>
#include <iostream>
#include <memory>
#include <vector>
#include <map>
#include <cmath>
#include <set>
#include <algorithm>
#include <iostream>
#include <queue>
#include <string>

#include "Graph.h"
#include "Node.h"
#include "Edge.h"
#include "Map.h"
#include "Game.h"
#include "UnitProperty.h"
#include "TileProperty.h"
#include "State.h"
#include "PlayingState.h"
#include "PauseState.h"
#include "ResultState.h"
#include "StateManager.h"
#include "Mymath.h"
#include "allegro5/allegro.h"
#include "allegro5/allegro_image.h"
#include "allegro5/allegro_native_dialog.h"
#include "allegro5/allegro_primitives.h"
#include "allegro5/allegro_font.h"

/**
 * Metodo principal do projeto
 */
int main() {

    ALLEGRO_DISPLAY *display;
    ALLEGRO_TIMER *timer;

    al_init();
    al_init_image_addon();
    al_init_primitives_addon();
    al_init_font_addon();
    al_init_ttf_addon();
    al_install_mouse();
    al_install_keyboard();


    display = al_create_display(800, 600);

    al_set_new_display_flags(ALLEGRO_RESIZABLE);
    al_set_window_title(display, "RTS2D");
    al_set_new_bitmap_flags(ALLEGRO_MIN_LINEAR | ALLEGRO_MAG_LINEAR);

    timer = al_create_timer(1.0 / MAX_FPS);

    al_start_timer(timer);

    ALLEGRO_EVENT_QUEUE* queue;
    queue = al_create_event_queue();
    al_register_event_source(queue, al_get_keyboard_event_source());
    al_register_event_source(queue, al_get_mouse_event_source());
    al_register_event_source(queue, al_get_display_event_source(display));
    al_register_event_source(queue, al_get_timer_event_source(timer));
    /*
    Game *game;
	Map* mapa = new Map("maps/map1.txt", "maps/config1.txt");
	game = new Game(mapa);
	*/
    StateManager* sm = new StateManager(display,timer,queue);
    //PlayingState::getInstance(display,timer,queue)->setGame(game);
    PlayingState::getInstance(display,timer,queue)->init();
    sm->changeState(PlayingState::getInstance(display,timer,queue));

    while(sm->isRunning()) {
        sm->readInput();
        sm->update();
        sm->render();
    }

    delete PlayingState::getInstance(display,timer,queue);
    delete PauseState::getInstance(display,timer,queue);
    delete ResultState::getInstance(display,timer,queue);
    delete BuildingProperty::getInstance();
    delete UnitProperty::getInstance();
    delete CommandProperty::getInstance();
    //delete mapa;
    //delete game;
    al_destroy_display(display);

    return 0;
}


