#include "Entity.h"

/**
 * Construtor
 */
Entity::Entity() {
    entity_ = NULL;
}

/**
 * Destrutor
 */
Entity::~Entity() {
}

/**
 * @return Coordenada x em pixel
 */
float Entity::getPx() {
    return px_;
}

/**
 * Atribui o valor da coordenada x em pixel
 * @param px Coordenada x em pixel
 */
void Entity::setPx(float px) {
    px_ = px;
}

/**
 * @return Coordenada y em pixel
 */
float Entity::getPy() {
    return py_;
}

/**
 * Atribui o valor da coordenada y em pixel
 * @param py Coordenada y em pixel
 */
void Entity::setPy(float py) {
    py_ = py;
}

/**
 * @return Tipo da entidade
 */
int Entity::getType() {
    return type_;
}

/**
 * Atribui o valor do tipo da entidade
 * @param type Tipo da entidade
 */
void Entity::setType(int type) {
    type_ = type;
}

/**
 * @return Time da entidade
 */
int Entity::getTeam() {
    return team_;
}

/**
 * Atribui um time a entidade
 * @param team Time da entidade
 */
void Entity::setTeam(int team) {
    team_ = team;
}

/**
 * @return Vida da entidade
 */
float Entity::getHp() {
    return hp_;
}

/**
 * Atribui o valor de vida da entidade
 * @param hp Vida da entidade
 */
void Entity::setHp(float hp) {
    hp_ = hp;
}

/**
 * @return Caminho em pixel da entidade
 */
std::vector<std::pair<float,float>> Entity::getPixelPath() {
    return pixelPath_;
}

/**
 * Atribui um caminho em pixel a entidade
 * @param pixelPath Caminho em pixel da entidade
 */
void Entity::setPixelPath(std::vector<std::pair<float,float>> pixelPath) {
    pixelPath_ = pixelPath;
}

/**
 * @return Ponteiro da entidade que esta iterando
 */
Entity* Entity::getEntity() {
    return entity_;
}

/**
 * Atribui uma entidade a ser iterada
 * @param entity Entidade sendo iterada
 */
void Entity::setEntity(Entity* entity) {
    entity_ = entity;
}

/**
 * @return true se for edificio, false caso contrario
 */
bool Entity::isBuilding() {
    return false;
}

/**
 * @return true se for unidade, false caso contrario
 */
bool Entity::isUnit() {
    return false;
}

/**
 * @return Par de coordenada da entidade
 */
std::pair<float,float> Entity::getCoordinates() {
    return std::make_pair(px_, py_);
}

/**
 * Atribui as coordenadas da entidade
 * @param px Coordenada x em pixel
 * @param py Coordenada y em pixel
 */
void Entity::setCoordinates(float px, float py) {
    px_ = px;
    py_ = py;
}

/**
 * Entidade recebe dano
 * @param damage Dano a ser recebido
 */
void Entity::receiveDamage(float damage) {
    hp_ = hp_-damage;
}
