#include "CommandProperty.h"

CommandProperty* CommandProperty::instance = NULL;

/**
 * Construtor
 */
CommandProperty::CommandProperty() {
    loadIcon();
    loadName();
}

/**
 * Destrutor
 */
CommandProperty::~CommandProperty() {
    printf("Deletando bitmaps de CommandProperty\n");
    for(int i = 0; i < COMMAND_TYPE::c_count; i++) {
        al_destroy_bitmap(icon_[i]);
    }
}

/**
 * Carrega nome do comando
 */
void CommandProperty::loadName() {
    name_[COMMAND_TYPE::MOVE] = "Move";
    name_[COMMAND_TYPE::STOP] = "Stop";
    name_[COMMAND_TYPE::ATTACK] = "Attack";
    name_[COMMAND_TYPE::UNLOAD] = "Unload";
    name_[COMMAND_TYPE::RALLY] = "Rally";
    name_[COMMAND_TYPE::GATHER] = "Gather";
}

/**
 * Carrega icone do comando
 */
void CommandProperty::loadIcon() {
    icon_[COMMAND_TYPE::MOVE] = al_load_bitmap("pictures/icons/move.png");
    icon_[COMMAND_TYPE::STOP] = al_load_bitmap("pictures/icons/stop.png");
    icon_[COMMAND_TYPE::ATTACK] = al_load_bitmap("pictures/icons/attack.png");
    icon_[COMMAND_TYPE::UNLOAD] = al_load_bitmap("pictures/icons/unload.png");
    icon_[COMMAND_TYPE::RALLY] = al_load_bitmap("pictures/icons/rally.png");
    icon_[COMMAND_TYPE::GATHER] = al_load_bitmap("pictures/icons/gather.png");
    for(int i = 0; i < COMMAND_TYPE::c_count; i++) {
        if(!icon_[i]) {
            printf("Erro ao carregar imagem\n");
            exit(1);
        }
    }
}

/**
 * @param type Tipo do comando
 * @return Nome do comando
 */
std::string CommandProperty::getName(int type) {
    return name_[type];
}

/**
 * @param type Tipo do comando
 * @return Icone do comando
 */
ALLEGRO_BITMAP* CommandProperty::getIcon(int type) {
    return icon_[type];
}

/**
 * Devolve o numero do tipo do comando de nome name
 * @param name Nome do comando
 * @return Indice do tipo do comando de nome name, -1 se nao existir
 */
int CommandProperty::getType(std::string name) {
    //printf("buscando\n");
    for(int i = 0; i < (int) name_.size(); i++) {
        if(name.compare(name_[i]) == 0) return i;
    }
    return -1;
}


