#include "ProjectileProperty.h"

ProjectileProperty* ProjectileProperty::instance = NULL;

/**
 * Construtor
 */
ProjectileProperty::ProjectileProperty() {
    loadSpeed();
    loadRadius();
    loadBitmap();
}

/**
 * Destrutor
 */
ProjectileProperty::~ProjectileProperty() {
    printf("Deletando bitmaps e instance de ProjectileProperty\n");
    for(int i = 0; i < PROJECTILE_TYPE::p_count; i++) {
        al_destroy_bitmap(bitmap_[i]);
    }
}

/**
 * Carrega velocidade dos projeteis
 */
void ProjectileProperty::loadSpeed() {
    speed_[PROJECTILE_TYPE::ARROW] = 300;
}

/**
 * Carrega raio de colisao dos projeteis
 */
void ProjectileProperty::loadRadius() {
    radius_[PROJECTILE_TYPE::ARROW] = 4;
}

/**
 * Carrega bitmap dos projeteis
 */
void ProjectileProperty::loadBitmap() {
    bitmap_[PROJECTILE_TYPE::ARROW] = al_load_bitmap("pictures/projectiles/arrow.png");
    for(int i = 0; i < PROJECTILE_TYPE::p_count; i++) {
        if(i != PROJECTILE_TYPE::MELEE && !bitmap_[i]) {
            printf("Erro ao carregar imagem projetil\n");
        }
    }
}

/**
 * @param type Tipo do projetil
 * @return Velocidade do projetil do tipo type
 */
float ProjectileProperty::getSpeed(int type) {
    return speed_[type];
}

/**
 * @param type Tipo do projetil
 * @return Raio de colisao do projetil do tipo type
 */
float ProjectileProperty::getRadius(int type) {
    return radius_[type];
}

/**
 * @param type Tipo do projetil
 * @return Bitmap do projetil do tipo type
 */
ALLEGRO_BITMAP* ProjectileProperty::getBitmap(int type) {
    return bitmap_[type];
}
